from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("numBatteries", 3, paramType="count", minValue=1, maxValue=10)

c.addSubcomponent("holder", "SimpleRectBeam", inherit=True, prefix=None)
c.addConstConstraint(("holder", "length"), 60)
c.addConstraint(("holder", "width"), "numBatteries", "9 * x")
c.addConstConstraint(("holder", "depth"), 17)

c.addSubcomponent("bottom", "Rectangle", inherit=True)
c.addConstraint(("bottom", "l"), ("numBatteries"), "9 * x")
c.addConstConstraint(("bottom", "w"), 17)

c.addConnection(("bottom", "t"), ("holder", "botedge0"), angle=90)
c.addConnection(("bottom", "l"), ("holder", "botedge1"), tabWidth=5, angle=90)
c.addConnection(("bottom", "r"), ("holder", "botedge3"),tabWidth=5, angle=90)
c.addConnection(("bottom", "b"), ("holder", "botedge2"), tabWidth=5, angle=90)

c.toLibrary("BatteryStackHolder")
