from rocolib.api.components import Component
from rocolib.api.composables.graph.Face import Face, Rectangle, RightTriangle
from rocolib.api.composables import GraphComposable as Graph
from rocolib.api.ports.EdgePort import EdgePort

class ServoHolder2(Component):
    _test_params = {
        'Length': 62.5
    }

    def define(self):
        self.addParameter("Length", 62.5)
        self.addInterface("SH2port", EdgePort(self, None, "Length"))
        self.addInterface("SH2star", EdgePort(self, None, "Length"))

    def assemble(self):
        l = float(self.getParameter("Length"))

        graph = Graph()
        base = Rectangle("", l, 40)
        graph.addFace(base, "base")

        self.composables["graph"] = graph
        self.setInterface("SH2port", EdgePort(self, "base.e3", "Length"))
        self.setInterface("SH2star", EdgePort(self, "base.e1", "Length"))

if __name__ == "__main__":
    h = ServoHolder2()
    h.test()